// coroner.gsc (bionic.nipple@gmail.com)
// Removes dead bodies and weapons laying on the ground. This prevents
// a no-free-entities error.

main(){
	thread searchForBodies();
}

//[Nip] Find dead bodied and weapons and bury them.
searchForBodies(){
	while(1){
		ents = getentarray();
		//[Nip] Search through all entities
		for (i=0;i<ents.size;i++){
			e = ents[i];
			if (e.classname == "noclass" && isDefined(e.model) && e.model != ""){
				//[Nip] Dead bodies are buried
				e thread bury();
			}else if (startswith(e.classname, "weapon_")){ //[Nip] Weapons
				if (!isDefined(e.targetname) || e.targetname != "weapons"){
					//[Nip] Only non-respawning weapons will be buried.
					e thread bury();
				}
			}
		}
		//[Nip] Warn if we're cutting it close.
		if (ents.size > 900){
			iprintln(&"FORTBHC_ENTITY_LIMIT");
		}
		wait 30;
	}
}

//[Nip] Lower the entity into the ground and delete it.
bury(){
	//[Nip] Don't bury twice. SHouldn't be a problem, but just in case.
	if (isDefined(self.burying))
		return;
	self.burying = true;
	//[Nip] Gradually increase the spead of fall
	for (i=0;i<64;i++){
		if (isDefined(self.origin))
			self.origin -= (0, 0, i);
		wait .05;
	}
	
	//[Nip] Remove the entity
	self delete();
}

//[Nip] Returns wether or not string starts with pattern.
// e.g assert(startsWith("mp_farmhouse", "mp_") == true);
startsWith(string, pattern){
    if (string == pattern) return true;
    if (pattern.size > string.size) return false;

    for (i=0; i<pattern.size; i++)
        if (string[i] != pattern[i]) return false;

    return true;
}