//basharena.gsc (bionic.nipple@gmail.com)
// Control the bash BBQ pit and the horn.

main(){
	level._effect["arena_flame"] = loadfx ("fx/fire/building_fire_large.efx");
	
	//[Nip] Nozzles are where the flames shoot up from in the floor.
	nozzles = getentarray("arena_nozzle", "targetname");
	if (isDefined(nozzles)){
		for (i=0;i<nozzles.size;i++){
			nozzles[i].home = nozzles[i].origin;
		}
	}
	
	//[Nip] Activate nozzles with this switch
	bbq_switch = getent("arena_bbq", "targetname");
	bbq_switch thread monitor_flameswitch();
	
	//[Nip] Activate horn with this switch
	horn_switch = getent("arena_horn", "targetname");
	horn_switch thread monitor_hornswitch();
	
}

monitor_flameswitch(){
	count = 0;
	while (1){
		self waittill("trigger", player);
		
		//[Nip] Light up the nozzles!
		nozzles = getentarray("arena_nozzle", "targetname");
		for (i=0;i<nozzles.size;i++){
			nozzles[i] thread torch();
		}
		
		wait 5;
	}
	
}

torch(){
	//raise the nozzle out of the ground
	while (self.origin[2] < self.home[2] + 12){
		self.origin = self.origin + (0, 0, 2);
		wait .1;
	}
	
	//[Nip] play fire fx
	playfx(level._effect["arena_flame"], self.origin + (0, 0, 12));
	sound = spawn("script_origin", self.origin);
	sound playLoopSound("medfire");
	wait 2;
	
	//[Nip] burn folks
	radiusDamage(self.origin + (0, 0, 12), 175, 100, 150);
	wait 2;
	sound delete();
	
	//[Nip] everythings over, lower the nozzle back down
	while (self.origin[2] > self.home[2]){
		self.origin = self.origin - (0, 0, 2);
		wait .1;
	}
}

monitor_hornswitch(){
	count = 0;
	while (1){
		self waittill("trigger", player);
		player playsound("truck_horn");
		wait 1;
	}
}
