//junglelane.gsc (bionic.nipple@gmail.com)
//Popup jungle lane targets in sequence and award points.
main(){
	thread monitor_triggers();
}

monitor_triggers(){
	player = undefined; //[Nip] The player running the course
	time = 0;
	while (true){
		//[Nip] Move through the target zones and pop appropriate targets.
		player = waitfor(1);
		time = gettime();
		choosetarget("1,2,3");
		waitfor(2);
		choosetarget("4,5,6");
		waitfor(3);
		choosetarget("7,8,9,10");
		waitfor(4);
		choosetarget("11,12,13,14");
		//waitfor(5); //[Nip] Not needed after all
		waitfor(6);
		choosetarget("15,16");
		waitfor(7);
		choosetarget("17,18,19");
		waitfor(8);
		choosetarget("20,21");
		waitfor(9);
		choosetarget("22,23");
		waitfor(10);
		choosetarget("24");
		waitfor(11);
		choosetarget("25,26,27");
		player2 = waitfor(12);
	}
}

//[Nip] Pop up a target and wait for it to be hit. Then move back down.
showtarget(id){
	ents = getentarray("jungle_target" + id, "targetname");
	target = false;
	trigger = false;
	for (i=0; i<ents.size; i++){
		if (ents[i].classname == "script_brushmodel"){
			target = ents[i];
		}else if (ents[i].classname == "trigger_damage"){
			trigger = ents[i];
		}
	}
	
	target playsound("truck_door_open");
	target moveto(target.origin + (0, 0, 28), .5);
	wait .5;
	
	time = 3; //[Nip] The time in seconds the trigger is shown
	uptime = gettime();
	trigger thread timeout(time);
	trigger waittill("trigger", player);
	if (isPlayer(player)){
		duration = (gettime() - uptime);
		flippoints = (time*1000) - duration;
		points = flippoints / (time*100);
		
		if (points < 0) points = 0;
		player.score += int(points);
		switch(int(points)){
			case 10: iprintln(&"FORTBHC_10_POINTS"); break;
			case 9: iprintln(&"FORTBHC_9_POINTS"); break;
			case 8: iprintln(&"FORTBHC_8_POINTS"); break;
			case 7: iprintln(&"FORTBHC_7_POINTS"); break;
			case 6: iprintln(&"FORTBHC_6_POINTS"); break;
			case 5: iprintln(&"FORTBHC_5_POINTS"); break;
			case 4: iprintln(&"FORTBHC_4_POINTS"); break;
			case 3: iprintln(&"FORTBHC_3_POINTS"); break;
			case 2: iprintln(&"FORTBHC_2_POINTS"); break;
			case 1: iprintln(&"FORTBHC_1_POINTS"); break;
		}
	}
	
	target playsound("car_door_close");
	target moveto(target.origin + (0, 0, -28), .2);
	wait .2;
	
}

//[Nip] After *time* seconds the target goes down by itself.
timeout(time){
	wait time;
	self notify("trigger");
}

waitfor(id){
	trigger = getent("jungle_zone" + id, "targetname");
	trigger waittill("trigger", player);
	return player;
}

//[Nip] Chose a taret from ids randomly and show it.
choosetarget(ids){
	ids = strTok(ids, ",");
	id = ids[randomint(ids.size)];
	showtarget(id);
}