//myminefields.gsc (bionic.nipple@gmail.com)
//Monitor minefield explosions. Rewritten from someone's original.
myminefields(){
	main();
}

main(){
	minefields = getentarray("myminefield", "targetname");
	if (isDefined(minefields)){
		//[Sky] might wanna change this to something BIGGER
		level._effect["mine_explosion"] = loadfx ("fx/explosions/grenadeExp_dirt.efx");
		for(i=0; i<minefields.size; i++){
			minefields[i] thread monitor_minefield();
		}
	}	
}

//[Nip] Wait for players to trip the minefield
monitor_minefield(){
	while (1){
		self waittill("trigger", player);
		if (isPlayer(player)) player thread explode();
	}
}

//[Nip] Player has tripped the minefield - kill them.
explode(){
	//[Nip] Don't get them twice
	if (isDefined(self.exploding))
		return;
		
	self.exploding = true;
	
	//[Nip] Uncomment this for "realistic" explosions
	//origin = self getorigin();
	
	self playsound ("minefield_click");
	
	wait .5 + randomFloat(.5);
	
	//[Nip] Coment this for explosions that follow player
	origin = self getorigin();
	
	//[Nip] Play explosion and damage.
	self playsound("explo_mine");
	playfx(level._effect["mine_explosion"], origin);
	radiusDamage(origin, 50, 200, 100);

	self.exploding = undefined;
}