main()
{
  WeaponRespawner("weapons", 5);
}

	WeaponRespawner(targetname, defaultrespawndelay)
{
	weapons = getentarray(targetname, "targetname");
	if(weapons.size > 0)
	{
	for(i=0; i < weapons.size; i++) 
		{
		if(!isdefined(weapons[i].script_timescale))
		weapons[i].script_timescale = defaultrespawndelay;

// start thread to listen for when the item gets picked up
	weapons[i] thread weapon_think(weapons[i].script_timescale);
		}
	}
}

// self = weapon reference
weapon_think(delaytime)
{
// capture important weapon data first to allow us to respawn them
	classname = self.classname;
	model = self.model;
	count = self.count;
	org = self.origin;
	angles = self.angles;

	targetname = self.targetname;

// Wait till the weapon gets picked up
	self waittill("trigger");

// Wait the delay before respawn
	wait delaytime;

// respawn the weapon
	weapon = spawn(classname, org);
	weapon.angles = angles;
	weapon.count = count;
	weapon setmodel(model); 
	weapon.script_timescale = delaytime;
	weapon.targetname = targetname;

// start new thread with the new weapon and kill the old one
	weapon thread weapon_think(delaytime);
}