//utils.gsc (bionic.nipple@gmail.com)
// Copied from BHCMod 2.1 It's here so the map can
// run without the mod.

//[Nip] Removes the color escape sequences from strings.
// e.g. assert(removeColor("^1{^2BHC^1}") == "{BHC}");
removeColor(string){
    blandString = "";
    escaped = false;
    for (i=0; i<string.size; i++){
        if (escaped){ //[Nip] When we're escaped, that means the previous character was a carat (i.e. "^").
            switch (string[i]){
                case "0":
                case "1":
                case "2":
                case "3":
                case "4":
                case "5":
                case "6":
                case "7":
                case "8":
                case "9":
                    //[Nip] If we're escaped and we encounter a number, ignore it - it's a color code.
                    escaped = false;
                    break;
                case "^":
                    //[Nip] Stay with me here. If we're escaped and we encounter another escape character
                    // assume the first escape character is literal, but remain escaped in case the next
                    // character is a number.
                    escaped = true;
                    blandString += "^";
                    break;
                default:
                    //[Nip] When we're escaped, but we don't find a following color number, assume the
                    // carat was literal.
                    blandString += "^"; //[Nip] Add the previous escape character back in.
                    blandString += string[i];
                    escaped = false;
                    break;
            }
        }else{
            if (string[i] == "^"){
                escaped = true;
            }else{
                blandString += string[i];
            }
        }
    }
    return blandString;
}

//[Nip] Returns wether or not string starts with pattern.
// e.g assert(startsWith("mp_farmhouse", "mp_") == true);
startsWith(string, pattern){
    if (string == pattern) return true;
    if (pattern.size > string.size) return false;

    for (i=0; i<pattern.size; i++)
        if (string[i] != pattern[i]) return false;

    return true;
}

//[Nip] Returns whether or not string ends with pattern.
// e.g assert(endsWith("mp_farmhouse", "house") == true);
endsWith(string, pattern){
    if (string == pattern) return true;
    if (pattern.size > string.size) return false;

    for (i=0; i<pattern.size; i++)
        if (string[string.size-1-i] != pattern[pattern.size-1-i]) return false;

    return true;        
}