//megaarty.gsc (bionic.nipple@gmail.com)
// There's a secret switch that launches super artillery somewhere. ;)

main(){
	level.secret_explosion = "fx/explosions/silo_explode.efx";
	level._effect["secretexplosion"] = loadfx(level.secret_explosion);
	
	precachemodel("xmodel/weapon_stickybomb");
	
	start_arty();
}

start_arty(){
	s = getentarray("secret_switch", "targetname");
	for (i=0; i<s.size;i++){
		s[i] thread monitor_megaarty();
	}
}

monitor_megaarty(){
	wait 10;
	
	secret_switch = self;
	secret_target = getent("secret_target", "targetname");
		
	position = secret_target.origin;

	//[Nip] Wait for activation
	while (1){
		secret_switch waittill("trigger", player);
		
		//[Nip] For some odd reason this gets triggered by a "ghost"
		//      FIXED: This shouldn't be a problem anymore, but the code doesn't
		//      hurt anything, so I'll leave it in just in case.
		if (!isPlayer(player)){
			wait 1;
			continue;
		}
		
		//[Nip] Intentional trigger?
		current = player getcurrentweapon();
		slot = "primary";
		if (player getweaponslotweapon(slot) != current) slot = "primaryb";
		if (3 != player getweaponslotclipammo(slot)) continue; //[Nip] Nope.
		
		wait 5; //[Nip] Give the mischief maker a chance to bolt
		
		shellEnt = spawn( "script_origin", position);
		shellEnt playsound( "artillery_incoming");
		
		wait 4;
			
		//[Nip] Visual arty Fx
		playfx( level._effect["secretexplosion"],position );
		
		shellEnt playsound( "building_explosion1" ); 
		
		//[Nip] Make the arty hurt
		earthquake(0.25, 0.75, shellEnt.origin, 2096);
		radiusDamage (shellEnt.origin, 1024, 120, 60);
		
		//[Nip] and we're done
		wait .05;
		shellEnt delete();
	}
}
	