//slots.gsc (bionic.nipple@gmail.com)
//Run a slot machine that uses your score as 'money\tokens'.

main(){
	thread monitor_slots();
}

monitor_slots(){
	lever = getent("slots_lever", "targetname");
	levertrigger = getent("slots_levertrigger", "targetname");

	//[Nip] 4 wheels as opposed to the normal 3
	reel1 = getent("slots_reel1", "targetname");
	reel2 = getent("slots_reel2", "targetname");
	reel3 = getent("slots_reel3", "targetname");
	reel4 = getent("slots_reel4", "targetname");

	
	rpc = 3; //[Nip] Number of revolutions per cycle
	dpc = rpc * 360; //[Nip] Degrees is a cycle
	speed = .5; //[Nip] Speed of cycles
	
	while(1){
		levertrigger waittill("trigger", player);
		
		player.score -= 5; //[Nip] It costs 5 to play
		
		//[Nip] Pretend the player pulled a lever
		lever rotateroll(25, .5);
		wait .5;
		
		//[Nip] 1st Cycle - all reels spin
		lever rotateto((0, 0, 0), .25);
		reel1 rotateroll(dpc * 2, speed * 2);
		reel2 rotateroll(dpc * 2, speed * 2);
		reel3 rotateroll(dpc * 2, speed * 2);
		reel4 rotateroll(dpc * 2, speed * 2);
		wait (speed * 2) + .05;
		//[Nip] 2nd Cycle - 1st reel slows and stops; all others spin
		reel1 rotateroll(dpc-360 + (randomint(4)*90), speed, 0, speed);
		reel2 rotateroll(dpc, speed);
		reel3 rotateroll(dpc, speed);
		reel4 rotateroll(dpc, speed);
		wait speed + .05;;
		//[Nip] 3rd Cycle - 2st reel slows and stops; all others spin
		reel2 rotateroll(dpc-360 + (randomint(4)*90), speed, 0, speed);
		reel3 rotateroll(dpc, speed);
		reel4 rotateroll(dpc, speed);
		wait speed + .05;
		//[Nip] 4th Cycle - 3st reel slows and stops; 4th spins
		reel3 rotateroll(dpc-360 + (randomint(4)*90), speed, 0, speed);
		reel4 rotateroll(dpc, speed);
		wait speed + .05;
		//[Nip] 5th Cycle - 4th reel slows and stops
		reel4 rotateroll(dpc-360 + (randomint(4)*90), speed, 0, speed);
		wait speed + .05;
		
		//[Nip] Grab the random angles for each reel so we know the "values"
		val1 = int(reel1.angles[2]/ 90);
		val2 = int(reel2.angles[2]/ 90);
		val3 = int(reel3.angles[2]/ 90);
		val4 = int(reel4.angles[2]/ 90);
		
		//[Nip] Score it and give the player points (if applicable)
		points = score(val1, val2, val3, val4);
		player.score += points;
	}
}

//[Nip] By having 4 reels with 4 possible value, scoring is
//      fairly simple. Just count pairs.
score (a, b, c, d){
	pairs = 0;
	pairs += a==b;
	pairs += a==c;
	pairs += a==d;
	pairs += b==c;
	pairs += b==d;
	pairs += c==d;
	
	switch (pairs){
	case 6: iprintln(&"SLOTS_FOUR_OF_A_KIND"); return 90;
	case 3: iprintln(&"SLOTS_THREE_OF_A_KIND"); return 7;
	case 2: iprintln(&"SLOTS_TWO_PAIR"); return 10;
	case 0: iprintln(&"SLOTS_STRAIGHT"); return 15;
	default: return 0; //[Nip] Must be 1 pair - no points sucka!
	}
}