//targetrange.gsc (bionic.nipple@gmail.com)
// Monitor the rifle range.
main(){
	//[Nip] Watch each of the 4 target stands
	thread monitor("1");
	thread monitor("2");
	thread monitor("3");
	thread monitor("4");
}

monitor(id){
	trigger = getent("range_target_" + id, "targetname");
	trigger thread monitor_damage(id);
	
	//[Nip] Each stand has 3 shutters (targets)
	shutter = [];
	shutter[0] = undefined;
	shutter[1] = getent("range_shutter_" + id + "1", "targetname");
	shutter[1].home = shutter[1].origin;
	shutter[1].origin = shutter[1].home + (0, 0, 32);
	shutter[2] = getent("range_shutter_" + id + "2", "targetname");
	shutter[2].home = shutter[2].origin;
	shutter[2].origin = shutter[2].home + (0, 0, 32);
	shutter[3] = getent("range_shutter_" + id + "3", "targetname");
	shutter[3].home = shutter[3].origin;
	shutter[3].origin = shutter[3].home + (0, 0, 32);
	
	//[Nip] Open one of the shutters, then close it again.
	while (true){
		i = randomint(3) + 1;
		shutter[i] moveto(shutter[i].home, .5);
		wait 1;
		shutter[i] moveto(shutter[i].home + (0, 0, 32), .5);
		wait 1 + (randomint(5) * .2);
	}
}

//[Nip] Wait for a target to be hit, and award points accordingly.
monitor_damage(id){
	switch(id){
	case "1": points = 2; pmsg = &"FORTBHC_2_POINTS"; break;
	case "2": points = 5; pmsg = &"FORTBHC_5_POINTS"; break;
	case "3": points = 10; pmsg = &"FORTBHC_10_POINTS"; break;
	case "4": points = 20; pmsg = &"FORTBHC_20_POINTS"; break;
	default:  points = 0; pmsg = &"FORTBHC_NO_POINTS"; break;
	}
	while (true){
		self waittill("damage", damage, player);
		getent("range_indicator_" + id, "targetname") rotateyaw(360, 1);
		player.score += points;
		iprintln(pmsg);
		wait 1;
	}
}
